



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>玩转X-CTR100 l STM32F4 l RNG硬件随机数发生器</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">玩转X-CTR100 l STM32F4 l RNG硬件随机数发生器</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 00:44:02 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1382322/201807/1382322-20180725161229219-1359900725.png" /></p>
<p>我造轮子，你造车，创客一起造起来！<strong>塔克创新</strong>资讯【塔克社区 <a href="http://www.xtark.cn/" rel="external nofollow noreferrer">www.xtark.cn</a> 】【塔克博客  <a href="http://www.cnblogs.com/xtark/" rel="external nofollow noreferrer">www.cnblogs.com/xtark/</a> 】</p>
<p>本文介绍X-CTR100控制器 STM32F4硬件随机数发生器生成随机数功能，可用于滤波、算法加密、验证等问题。</p>
<h1>原理</h1>
<p>STM32F4自带了硬件随机数发生器（RNG），RNG处理器是一个以连续模拟噪声为基础的随机数发生器，在主机读数时提供一个32位的随机数。</p>
<p>STM32F4的随机数发生器框图。</p>
<p>    <img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1382322/201807/1382322-20180725161230234-776935677.png" /></p>
<h1>例程</h1>
<p>本例程实现产生任意随机数和0至99范围随机数，并串口输出显示。</p>
<h2>硬件说明</h2>
<p>硬件资源：</p>
<ul><li>串口UART1</li></ul>
<p>硬件连接：</p>
<p>使用MicroUSB数据线连接X-CTR100 COM接口。</p>
<h2>软件生态</h2>
<p>X-SOFT软件生态，X-API文件如下。</p>
<p>ax_rng.c——X-CTR100 硬件随机数产生器源文件</p>
<p>ax_rng.h——X-CTR100 硬件随机数产生器头文件</p>
<p>操作函数如下：</p>
<div>
<table>
<tbody>
<tr>
<td>
<p>void AX_RNG_Init(void);  //RNG初始化</p>
<p>int32_t AX_RNG_GetRandomNum(void);  //RNG获取随机数</p>
<p>uint32_t AX_RNG_GetRandomNum_Range(uint32_t min, uint32_t max);  //RNG获取范围内随机数</p>
</td>
</tr>
</tbody>
</table>
</div>
<h2>软件说明</h2>
<p>主程序。</p>
<div>
<table>
<tbody>
<tr>
<td>
<p>int main(void)</p>
<p>{</p>
<p>    int32_t random;</p>
<p> </p>
<p>    /* X-CTR100初始化 */</p>
<p>    AX_Init(115200);</p>
<p>    printf("***X-CTR100 RNG硬件随机数产生器例程***\r\n\r\n");</p>
<p> </p>
<p>    //模块初始化及配置</p>
<p>    AX_RNG_Init();</p>
<p> </p>
<p>    while (1)</p>
<p>    {</p>
<p>        //获取任意随机数</p>
<p>        random = AX_RNG_GetRandomNum();</p>
<p>        printf("任意随机数：%d   ", random);</p>
<p> </p>
<p>        //获取[0-99]任意随机数</p>
<p>        random = AX_RNG_GetRandomNum_Range(0, 99);</p>
<p>        printf("随机数[0-99]：%d \r\n", random);</p>
<p> </p>
<p>        AX_Delayms(1000);</p>
<p>        AX_LEDG_Toggle();</p>
<p>    }</p>
<p>}</p>
</td>
</tr>
</tbody>
</table>
</div>
<h2>实现效果</h2>
<p>运行效果如下图所示。</p>
<p>    <img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1382322/201807/1382322-20180725161232276-623189448.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7l75x8.html">Python学习笔记 for windows 三</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gggpz9.html">ASP&period;NET 表单验证实现浅析</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxy7v09.html">Eclipse：Dubug快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydx0d2q.html">Unity3d 巫师3Ciri的渲染</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oeeyv9.html">&period;net core3</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm6j219.html">Pojo和JavaBean的区别&lpar;转载&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpjel39.html">Git - error&colon; RPC failed&semi; result&equals;22&comma; HTTP code &equals; 401 fatal&colon; The remote end hung up unexpectedly</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z7nj19.html">js基础和工具库</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgylk78.html">Java Web快速入门&mdash;&mdash;全十讲</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkje7j8.html">c语言一&comma;二数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zv66k9.html">promise 的基本概念 和如何解决js中的异步编程问题 对 promis 的 then all ctch 的分析 和  await async 的理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdlred9.html">LSI IBM服务器阵列卡操作经历</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllm0x0q.html">搞懂iobuffer就得先学习bytebuffer</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rr4ej9.html">Metasploit Framework（7）客户端渗透（下）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r507ymq.html">spark中RDD的转化操作和行动操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjgzll9.html">Java学习之路-Hessian学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj45mr9.html">elaticsear no &lbrack;query&rsqb; registered for &lbrack;filtered&rsqb; 错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvpr4y8.html">JavaScript&lowbar;几种创建对象&lpar;2017-07-04&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7explj9.html">div文本垂直居中&lpar;div text vertical aligan&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pjz5g8.html">43&lpar;function pointer 1&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93w46xgq.html">LeetCode--013--罗马数字转整数（java）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25z6loq.html">用 JS 设置图片的最大宽度</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy7xpdq.html">反射API（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/960rkny9.html">Jupyter notebook 转 pdf &lbrack;完整转换&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1o6p09.html">vim操作&lpar;待补充&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllr0v1q.html">QQ企业邮箱接口</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjeg139.html">Leetcode  1013&period; 总持续时间可被 60 整除的歌曲</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w44grq.html">&lbrack;CodeForces - 197E&rsqb; E - Paint Tree</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd3vej9.html">ORM框架之SQLALchemy</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw4r178.html">vue数组操作不更新视图问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
